function varargout = clustersTextualResults(varargin)
% CLUSTERSTEXTUALRESULTS M-file for clustersTextualResults.fig
%      CLUSTERSTEXTUALRESULTS, by itself, creates a new CLUSTERSTEXTUALRESULTS or raises the existing
%      singleton*.
%
%      H = CLUSTERSTEXTUALRESULTS returns the handle to a new CLUSTERSTEXTUALRESULTS or the handle to
%      the existing singleton*.
%
%      CLUSTERSTEXTUALRESULTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLUSTERSTEXTUALRESULTS.M with the given input arguments.
%
%      CLUSTERSTEXTUALRESULTS('Property','Value',...) creates a new CLUSTERSTEXTUALRESULTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before clustersTextualResults_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to clustersTextualResults_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustersTextualResults

% Last Modified by GUIDE v2.5 22-Mar-2004 02:09:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustersTextualResults_OpeningFcn, ...
    'gui_OutputFcn',  @clustersTextualResults_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before clustersTextualResults is made visible.
function clustersTextualResults_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to clustersTextualResults (see VARARGIN)

% Choose default command line output for clustersTextualResults
handles.output = hObject;
handles.real=[];
handles.calc=[];
handles.note=[];
handles.inputStr=[];
handles.dimsStr=[];
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'title'
                set(hObject, 'Name', varargin{index+1});
            case 'string'
                set(handles.text1, 'String', varargin{index+1});
             case  'real'
                 handles.real = varargin{index+1}; 
             case  'calc'
                 handles.calc = varargin{index+1};
             case 'note'
                  handles.note = varargin{index+1};
              case 'inputstr'
                  handles.inputStr = varargin{index+1};
              case 'dimsstr'
                  handles.dimsStr = varargin{index+1};
          end
    end
end

if 1 == isempty(handles.real)
    string = ['No Real Mapping is available'];
else
    nonemptyVector= find(handles.calc);%if I selected  'pure' QC I need to take only the non zero elements.
    calcToMeasure = handles.calc(nonemptyVector);
    realToMeasure = handles.real(nonemptyVector);
    [jaccard,purity,efficiency]=calculateJaccardByReference(calcToMeasure,realToMeasure);
    [jPairs,ePairs, pPairs,PE] =myClustMeasure(calcToMeasure, realToMeasure);
    string{1} = [''];
    string{2} = ['Clustering Results:'];
    string{3} = ['=============='];
    string{4} = [handles.dimsStr(1,:)];
    string{5} =[handles.dimsStr(2,:)];
    string{6}= ['Results of ',handles.inputStr,': ',handles.note];
    string{7}= [ ' '];
    string{8} = ['Pair-wise calculation:'];
    string{9} = ['================='];  
    string{10} = ['Jaccard score: ',num2str(jPairs),', Purity: ', num2str(pPairs),', Efficiency: ', num2str(ePairs)];
    string{11} = ['Results of ',handles.inputStr,': ',handles.note];
    string{12}= [ ' '];    
    string{13} = ['Calculation for each cluster:'];
    string{14} = ['======================'];  
    string{15} = ['There are ', num2str(max(handles.real)), ' clusters in the real data'];
    string{16} =['Algorithm have found ', num2str(max(handles.calc)), ' clusters'];
    str=[];%init
    for ind=1:length(jaccard)% go over all the clusters and collect the values
         string{16+ind} = ['Cluster ', num2str(ind),'- Jaccard: ', num2str(jaccard(ind)), ', Purity: '...
              num2str(purity(ind)), ', Efficiency: ' num2str(efficiency(ind))];
      %  str = strcat(str,str1);
    end
    %string = strcat(opening,strPairs);
    %string = strcat(string,strDetails);
    %string = strcat(string,str);
end
% position =get(handles.axesTag,'Position');
%text(position(1),position(2),string);
% text(0,position(4),string);
% axis off;
%box on;
set(handles.editTag,'String',string);

% Update handles structure
guidata(hObject, handles);
% UIWAIT makes clustersTextualResults wait for user response (see UIRESUME)
uiwait(handles.clustersTextualResults);


% --- Outputs from this function are returned to the command line.
function varargout = clustersTextualResults_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% The figure can be deleted now
delete(handles.clustersTextualResults);

% --- Executes on button press in closeTag.
function closeTag_Callback(hObject, eventdata, handles)
% hObject    handle to closeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
CloseMenuItem_Callback(hObject, eventdata, handles)

function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg(['Close ' get(handles.clustersTextualResults,'Name') '?'],...
    ['Close ' get(handles.clustersTextualResults,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

% Update handles structure
guidata(hObject, handles);
uiresume(handles.clustersTextualResults);


% --- Executes when user attempts to close clustersTextualResults.
function clustersTextualResults_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to clustersTextualResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


% --------------------------------------------------------------------
function SaveMenu_Callback(hObject, eventdata, handles)
% hObject    handle to SaveMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function saveTextItem_Callback(hObject, eventdata, handles)
% hObject    handle to saveTextItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
string=get(handles.editTag,'String');
[varsout{1:4}] = fileBrowser('dir','pwd','format','txt');
dir  = varsout{2};
file = varsout{3};
format = varsout{4};
if 0 == isempty(file)%file was selected
    fullfile = [dir , '\',file,'.',format];
    fid = fopen(fullfile,'w');%open a file to write
    fprintf(fid,'QUI Clustering tool Log file\n');%start writing
    c=clock;%the time
    cStr=datestr(c);% as string
    fprintf(fid,'Current Date and Time: ');
    fprintf(fid,cStr);
    for ind =1: length(string)
        fprintf(fid,'\n');    
        fprintf(fid,string{ind});
    end
    fclose(fid);
end

% --------------------------------------------------------------------
function ToMatlabItm_Callback(hObject, eventdata, handles)
% hObject    handle to ToMatlabItm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
string=get(handles.editTag,'String');
[varsout{1:4}] = fileBrowser('dir','pwd','format','mat');
dir  = varsout{2};
file = varsout{3};
format = varsout{4};
calculatedMapping = handles.calc;
realMapping = handles.real;
if 0 == isempty(file)
    fullfile = [dir , '\',file,'.',format] ;
    save (fullfile ,'string','calcMapping') ;
end



% --------------------------------------------------------------------
function printMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to printMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

printdlg('-crossplatform',handles.clustersTextualResults);


% --- Executes during object creation, after setting all properties.
function editTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function editTag_Callback(hObject, eventdata, handles)
% hObject    handle to editTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTag as text
%        str2double(get(hObject,'String')) returns contents of editTag as a double


