function varargout = clustersTool2(varargin)
% CLUSTERSTOOL2 M-file for clustersTool2.fig
%      CLUSTERSTOOL2, by itself, creates a new CLUSTERSTOOL2 or raises the existing
%      singleton*.
%
%      H = CLUSTERSTOOL2 returns the handle to a new CLUSTERSTOOL2 or the handle to
%      the existing singleton*.
%
%      CLUSTERSTOOL2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLUSTERSTOOL2.M with the given input arguments.
%
%      CLUSTERSTOOL2('Property','Value',...) creates a new CLUSTERSTOOL2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before clustersTool2_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to clustersTool2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustersTool2

% Last Modified by GUIDE v2.5 15-Feb-2005 11:39:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustersTool2_OpeningFcn, ...
    'gui_OutputFcn',  @clustersTool2_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before clustersTool2 is made visible.
function clustersTool2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to clustersTool2 (see VARARGIN)

% Choose default command line output for clustersTool2
handles.output = hObject;
handles.stageSelected = 'cancel';
handles.selectedDims = 0;
dimsOption =0;
handles.preprocessing =0;
dimsStr =[];
handles.toCluster = 1;% rows
handles.bic =0;
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'title'
                set(hObject, 'Name', varargin{index+1});
            case 'string'
                set(handles.text1, 'String', varargin{index+1});
            case  'maxdims'
                handles.numMaxDims = varargin{index+1};
            case 'data'
                handles.data  = varargin{index+1};
            case 'preprocessing'  
                handles.preprocessing= varargin{index+1};
            case 'dimsoption'
                dimsOption = varargin{index+1};
            case 'dimsstr'
                dimsStr= varargin{index+1};
            case 'clustercolumns'
                handles.toCluster= varargin{index+1};
            case 'bic'
                handles.bic= varargin{index+1};
            case 'matrixstr'
                set(handles.matrixShapeTag,'String',varargin{index+1});
                % Update handles structure
               %guidata(hObject, handles);
        end
    end
end

entropy = plotSVDComponents(handles.data);
set(handles.entropyTag,'String',num2str(entropy));
% Update handles structure
guidata(hObject, handles);

switch dimsOption
    case 0 % default
        set(handles.firstDimsEditTag,'String',handles.numMaxDims);
    case 1 %first dims
        if isempty(dimsStr)
            dimsStr = num2str(handles.numMaxDims);
        end
        set(handles.firstDimsEditTag,'String',dimsStr);
        set( handles.fromToRadioTag,'Value',0.0);
        set( handles.selectRadioTag,'Value',0.0);
        set( handles.firstDimsRadioTag,'Value',1.0);
    case 2% from to
        range =strfind(dimsStr,'-');
        from = dimsStr(1:range-1);
        to = dimsStr(range+1:length(dimsStr));
        set(handles.fromEditTag,'String',from);
        set(handles.toEditTag,'String',to);
        set( handles.fromToRadioTag,'Value',1.0);
        set( handles.selectRadioTag,'Value',0.0);
        set( handles.firstDimsRadioTag,'Value',0.0);
    case 3 %selection
        set(handles.selectEditTag,'String',dimsStr);
        set( handles.fromToRadioTag,'Value',0.0);
        set( handles.selectRadioTag,'Value',1.0);
        set( handles.firstDimsRadioTag,'Value',0.0);
end

switch handles.preprocessing
    case 0%do nothing
        set(handles.normalizeCheckTag,'Value',0.0);
        set(handles.svdCheckTag,'Value',0.0);
    case 1%only svd
        set(handles.normalizeCheckTag,'Value',0.0);
        set(handles.svdCheckTag,'Value',1.0);
        set(findobj(gcf,'Tag','normalizeCheckTag'),'Enable','on');
    case 2 %svd + normalize
        set(handles.normalizeCheckTag,'Value',1.0);
        set(handles.svdCheckTag,'Value',1.0);
        set(findobj(gcf,'Tag','normalizeCheckTag'),'Enable','on');
end
if handles.toCluster ==1%rows or columns
    set( handles.rowsOrCulomnsTag,'String','columns');
else
        set( handles.rowsOrCulomnsTag,'String','rows');
end
% UIWAIT makes clustersTool2 wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = clustersTool2_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
if get(handles.svdCheckTag,'Value')==0
    preprocessing = 0;%do nothing
elseif get(handles.normalizeCheckTag,'Value')==0% use svd
    preprocessing =1;%only SVD
else
    preprocessing =2;%SVD + normalize
end

if get(handles.firstDimsRadioTag,'Value')==1
    dimsOption=1;
    dimsStr = get(handles.firstDimsEditTag,'String');
elseif get(handles.fromToRadioTag,'Value')==1
    dimsOption =2;
    from =get(handles.fromEditTag,'String');
    to=get(handles.toEditTag,'String');
    dimsStr = [from,'-',to];
else % selection
    dimsOption =3;    
    dimsStr =get(handles.selectEditTag,'String');
end
varargout{1} = handles.output;
varargout{2} = handles.stageSelected;
varargout{3} = preprocessing;
varargout{4} = handles.selectedDims;
varargout{5}= dimsOption;
varargout{6}= dimsStr;
varargout{7}= 0;
% The figure can be deleted now
delete(handles.figure1);

% --- Executes on button press in firstDimsRadioTag.
function firstDimsRadioTag_Callback(hObject, eventdata, handles)
% hObject    handle to firstDimsRadioTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of firstDimsRadioTag

% Hint: get(hObject,'Value') returns toggle state of FromToRadioTag
on = get(hObject,'Value');
if on ==1.0
    set( handles.fromToRadioTag,'Value',0.0);
    set( handles.selectRadioTag,'Value',0.0);
else
    set( handles.firstDimsRadioTag,'Value',1.0);
end

function firstDimsEditTag_Callback(hObject, eventdata, handles)
% hObject    handle to firstDimsEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of firstDimsEditTag as text
%        str2double(get(hObject,'String')) returns contents of firstDimsEditTag as a double
dims = str2num(get(hObject,'String'));
if dims > handles.numMaxDims || dims < 2
    str = ['You must specify an Integer bigger than 1 and not bigger than ', num2str(handles.numMaxDims)];
    errordlg(str,'Incorrect value','modal');  
    set(hObject,'String','2');
else%good
    handles.selectedDims = [1:1:dims];
    set( handles.firstDimsRadioTag,'Value',1.0);
    firstDimsRadioTag_Callback(handles.firstDimsRadioTag, eventdata, handles);
end

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function fromEditTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fromEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function fromEditTag_Callback(hObject, eventdata, handles)
% hObject    handle to fromEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fromEditTag as text
%        str2double(get(hObject,'String')) returns contents of fromEditTag as a double
from =str2num(get(hObject,'String'));
if isempty(get(handles.toEditTag,'String'))
    to = handles.numMaxDims;
else
    to = str2num(get(handles.toEditTag,'String'));
end
if from < 1 || (to -from ) <1
    str = ['You must specify an Integer bigger than 1 and smaller than ', num2str(to), '.', char(10),'Range must be at least 2'];
    errordlg(str,'Incorrect value','modal');  
    set(hObject,'String','');
else
    handles.selectedDims = [from:1:to];
    set( handles.fromToRadioTag,'Value',1.0);
    fromToRadioTag_Callback(handles.fromToRadioTag, eventdata, handles);
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function toEditTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to toEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function toEditTag_Callback(hObject, eventdata, handles)
% hObject    handle to toEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of toEditTag as text
%        str2double(get(hObject,'String')) returns contents of toEditTag as a double

to =str2num(get(hObject,'String'));
if isempty(get(handles.fromEditTag,'String'))
    from = 1;
else
    from = str2num(get(handles.fromEditTag,'String'));
end
if to > handles.numMaxDims || (to -from ) <1
    str = ['You must specify an Integer not bigger than ', num2str(handles.numMaxDims), ' and bigger than ', num2str(from), ', by at least 2'];
    errordlg(str,'Incorrect value','modal');  
    set(hObject,'String','');
else
    handles.selectedDims = [from:1:to];
    set( handles.fromToRadioTag,'Value',1.0);
    fromToRadioTag_Callback(handles.fromToRadioTag, eventdata, handles);
end
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function selectEditTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selectEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function selectEditTag_Callback(hObject, eventdata, handles)
% hObject    handle to selectEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of selectEditTag as text
%        str2double(get(hObject,'String')) returns contents of selectEditTag as a double
str =get(hObject,'String') ;
[isValid,dimsArray]=parseSelectedDimsStr(str,handles.numMaxDims);
if isValid==0
    set(hObject,'String','');
else
    handles.selectedDims = find(dimsArray);
    set( handles.selectRadioTag,'Value',1.0);
    selectRadioTag_Callback(handles.selectRadioTag, eventdata, handles);
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in svdCheckTag.
function svdCheckTag_Callback(hObject, eventdata, handles)
% hObject    handle to svdCheckTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of svdCheckTag
isToggled =get(hObject,'Value');
if isToggled
    set(findobj(gcf,'Tag','normalizeCheckTag'),'Enable','on');
else
    set(findobj(gcf,'Tag','normalizeCheckTag'),'Enable','off');
end


% --- Executes on button press in normalizeCheckTag.
function normalizeCheckTag_Callback(hObject, eventdata, handles)
% hObject    handle to normalizeCheckTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of normalizeCheckTag


% --- Executes on button press in nextTag.
function nextTag_Callback(hObject, eventdata, handles)
% hObject    handle to nextTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.stageSelected = 'next';
error=0;
%finding the dimensions
dimsRadio =get(handles.firstDimsRadioTag,'Value');
if dimsRadio ==1
    if isempty(get(handles.firstDimsEditTag,'String'))
        error = 1;
    else
        dims = str2num(get(handles.firstDimsEditTag,'String'));
        handles.selectedDims = [1:1:dims];
    end
else
    dimsRadio =get(handles.fromToRadioTag,'Value');
    if dimsRadio ==1
        if isempty(get(handles.fromEditTag,'String')) || isempty(get(handles.toEditTag,'String'))
            error =1;
        else
            from = str2num(get(handles.fromEditTag,'String'));
            to =str2num(get(handles.toEditTag,'String'));
            handles.selectedDims = [from:1:to];
        end
    else
        [isValid,dimsArray]=parseSelectedDimsStr(get(handles.selectEditTag,'String') ,handles.numMaxDims);
        error = ~isValid;
        handles.selectedDims=find(dimsArray);
    end
end
if error ==1
    errordlg('You must specify dimensions','Incorrect value','modal');  
else
    % Update handles structure
    guidata(hObject, handles);
    uiresume(handles.figure1);
end
% --- Executes on button press in cancelTag.
function cancelTag_Callback(hObject, eventdata, handles)
% hObject    handle to cancelTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
handles.stageSelected = 'cancel';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);
% --- Executes on button press in backTag.
function backTag_Callback(hObject, eventdata, handles)
% hObject    handle to backTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.stageSelected = 'back';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);
% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)



% --- Executes during object creation, after setting all properties.
function firstDimsRadioTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firstDimsRadioTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'Value',1.0);


% --- Executes on button press in selectRadioTag.
function selectRadioTag_Callback(hObject, eventdata, handles)
% hObject    handle to selectRadioTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of selectRadioTag
on = get(hObject,'Value');
if on ==1.0
    set( handles.firstDimsRadioTag,'Value',0.0);
    set( handles.fromToRadioTag,'Value',0.0);
else
    set( handles.selectRadioTag,'Value',1.0);
end


% --- Executes on button press in fromToRadioTag.
function fromToRadioTag_Callback(hObject, eventdata, handles)
% hObject    handle to fromToRadioTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of fromToRadioTag
on = get(hObject,'Value');
if on ==1.0
    set( handles.firstDimsRadioTag,'Value',0.0);
    set( handles.selectRadioTag,'Value',0.0);
else
    set( handles.fromToRadioTag,'Value',1.0);
end


% --- Executes during object creation, after setting all properties.
function firstDimsEditTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to firstDimsEditTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


%function [isValid,dimsArray]=parseSelectedDimsStr(remainder,maxAllowed)
% parseSelectedDimsStr: function parses expressions like '1,2,4,5-10,12'
% Input:
% remainder - input expression
% maxAllowed - maximum number that is allowed (number of dimensions
% Output:
% isValid - is the expression valid
% dimsArray - 0,1 array of the selected dimensions

function [isValid,dimsArray]=parseSelectedDimsStr(remainder,maxAllowed)
isValid = 1;
dimsArray = zeros(1,maxAllowed);
while (any(remainder))
    [chopped,remainder] = strtok(remainder,',');
    range =strfind(chopped,'-');% look for the expression: '2 - 4'
    if isempty(range) %not a range
        if isempty(chopped)
            continue;
        end
        num = str2num(chopped);
        if isempty(num)|| num <1 || num > maxAllowed
            str = ['The value you specified (',chopped, ') is not legal'];
            errordlg(str,'Incorrect value','modal');  
            isValid = 0;
            break;
        else
            dimsArray(num) =1;
        end
    elseif length (range )>1 || range == 1 || range == length(chopped) %not a valid range
        str = ['The value you specified (',chopped, ') is not legal'];  
        isValid = 0;
    else
        from = str2num(chopped(1:range-1));
        to = str2num(chopped(range+1:length(chopped)));
        if isempty(to)|| isempty(from)||from < 1 || from >= to || to > maxAllowed%illegal range
            str = ['The value you specified (',chopped, ') is not legal'];  
            isValid = 0;
        end
        if isValid==0;
            errordlg(str,'Incorrect value','modal');  
            break;
        else
            dimsArray(from:to)=1;
        end
    end
end%while


function [entropy] = plotSVDComponents(data)
[numberOfGenes,numberOfSamples] = size(data);
if numberOfGenes < numberOfSamples
    data =data';
end
[eigenSamples,S,eigenGenes] = svd(data,0);%   svd the input    X = USVt because genes information is displaeyd in eigensamples base and vice versa
[x,y] =size(S);% it isn't always equal
if x~=y
    minDim = min(x,y);
    S = S(1:minDim,1:minDim);% make it square
end
[dims,entropy] = estimateNumberOfSignificantDims(S,1);  % number of significant dimension to process

% --- Executes on button press in clusterRowsTag.
function clusterRowsTag_Callback(hObject, eventdata, handles)
% hObject    handle to clusterRowsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of clusterRowsTag
on = get(hObject,'Value');
if on ==1.0
    set( handles.clusterColumnsTag,'Value',0.0);
    handles.toCluster=0;
else
    set( handles.clusterColumnsTag,'Value',1.0);
    handles.toCluster=1;
end

% --- Executes on button press in clusterColumnsTag.
function clusterColumnsTag_Callback(hObject, eventdata, handles)
% hObject    handle to clusterColumnsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of clusterColumnsTag

on = get(hObject,'Value');
if on ==1.0
    set( handles.clusterRowsTag,'Value',0.0);
    handles.toCluster=1;
else
    set( handles.clusterRowsTag,'Value',1.0);
    handles.toCluster=0;
end




