function varargout = clustersToolMethods(varargin)
% CLUSTERSTOOLMETHODS M-file for clustersToolMethods.fig
%      CLUSTERSTOOLMETHODS, by itself, creates a new CLUSTERSTOOLMETHODS or raises the existing
%      singleton*.
%
%      H = CLUSTERSTOOLMETHODS returns the handle to a new CLUSTERSTOOLMETHODS or the handle to
%      the existing singleton*.
%
%      CLUSTERSTOOLMETHODS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLUSTERSTOOLMETHODS.M with the given input arguments.
%
%      CLUSTERSTOOLMETHODS('Property','Value',...) creates a new CLUSTERSTOOLMETHODS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before clustersToolMethods_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to clustersToolMethods_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustersToolMethods

% Last Modified by GUIDE v2.5 21-Feb-2005 14:44:21

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustersToolMethods_OpeningFcn, ...
    'gui_OutputFcn',  @clustersToolMethods_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before clustersToolMethods is made visible.
function clustersToolMethods_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to clustersToolMethods (see VARARGIN)

% Choose default command line output for clustersToolMethods
handles.output = hObject;
handles.stageSelected = 'cancel';
handles.mapping =[];
handles.data=[];
handles.calcMapping=[];
handles.note =[];
handles.QCFrames=0;
handles.SVCCoreMapping = -1;
method=1;
dims=[];
preprocessing=[];
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'title'
                set(hObject, 'Name', varargin{index+1});
            case 'string'
                set(handles.text1, 'String', varargin{index+1});
            case  'mapping'
                handles.mapping = varargin{index+1};
            case 'data'
                handles.data  = varargin{index+1};
            case 'dims'
                dims =varargin{index+1};
            case 'preprocessing'
                preprocessing =varargin{index+1};
            case 'method'
                method=varargin{index+1};
        end
    end
end


str = ['Input data: ', dims, ' dimensions were selected', char(10), 'Preprocessing: ',preprocessing];
set(handles.dimensionsTextTag,'String',str);
set(handles.methodTag,'Value',method);
% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using clustersToolMethods.
% if strcmp(get(hObject,'Visible'),'off')
%     plot(rand(5));
% end

plotClassification(handles.mapping,  handles.data,0);

% UIWAIT makes clustersToolMethods wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = clustersToolMethods_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
varargout{2} =handles.stageSelected;
varargout{3}= handles.calcMapping;
varargout{4}=get(handles.methodTag,'Value');
varargout{5}= handles.note ;
varargout{6}= get(handles.dimensionsTextTag,'String');
varargout{7}= handles.QCFrames;
varargout{8}=handles.SVCCoreMapping;
delete(handles.figure1)
% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --- Executes during object creation, after setting all properties.
function methodTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to methodTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in methodTag.
function methodTag_Callback(hObject, eventdata, handles)
% hObject    handle to methodTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns methodTag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from methodTag
val = get(hObject,'Value');
string_list = get(hObject,'String');
selected_string = string_list{val}; % convert from cell array to
handles.method = selected_string;

% --- Executes on button press in cancelTag.
function cancelTag_Callback(hObject, eventdata, handles)
% hObject    handle to cancelTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
handles.stageSelected = 'cancel';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in nextTag.
function nextTag_Callback(hObject, eventdata, handles)
% hObject    handle to nextTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
switch get(handles.methodTag,'Value');
    case 1% kmeans (from the statistical toolbox
        [varsout{1:2}]  = numOfClassesDlg;
        numOfClusters = varsout{1};
        mode = varsout{2};
        if mode ==0
            return
        end
        handles.calcMapping = kmeans(handles.data,numOfClusters);
        handles.note =['Kmeans Classification' ];
    case 2%fuzzy kmeans
        [varsout{1:6}] = fuzzyCMeansDlg;
        numOfClusters =varsout{1};
        exp=varsout{2};
        iters=varsout{3};
        eps=varsout{4};
        info=varsout{5};
        mode = varsout{6};
        if mode ==0
            return
        end
        handles.calcMapping = referenceClustering(handles.data,numOfClusters,exp,iters,eps,info);
        handles.note =['Fuzzy c means Classification' ];
    case 3%NN
        [varsout{1:4}] = paramsForCNNDlg;
        learningRate = varsout{1};
        steps = varsout{2};
        nClust = varsout{3};
         mode = varsout{4};
        if mode ==0
            return
        end
        handles.calcMapping = cnnClustering(steps,learningRate, handles.data,1,nClust);
        handles.note =  ['Competitive NN Classification (', int2str(steps), ' iterations)' ];
    case 4%QC
        [varsout{1:5}] = paramsForQCDlg;
        sigma = varsout{1};
        steps = varsout{2};
        usePureQc=varsout{3};
        percent = varsout{4};
         mode = varsout{5};
        if mode ==0
            return
        end
        if usePureQc == 1
            handles.calcMapping= pureQC(handles.data, sigma,steps,percent,1);%last parameter is a 'show' flag
            handles.note  = ['Pure QC Classification (', int2str(steps), ' iterations, sigma = ', num2str(sigma),', percent of pure elements: ', num2str(percent),')' ];
        else
            handles.calcMapping= qcClustering(sigma,steps, handles.data);
            handles.note  = ['QC Classification (', int2str(steps), ' iterations, sigma = ', num2str(sigma),')' ];
        end
    case 5 %Second order
        [varsout{1:23}] = secondOrderClusteringDlg;
         mode = varsout{23};
        if mode ==0
            return
        end
        soc.kmeans.check= varsout{1}  ;
        soc.kmeans.clust=varsout{2};
        soc.kmeans.sols=varsout{3} ;
        soc.kmeans.weight=varsout{4};
        %fcm
        soc.fcm.check=varsout{5} ;
        soc.fcm.clust=varsout{6} ;
        soc.fcm.exp=varsout{7} ;
        soc .fcm.iters=varsout{8};
        soc.fcm.eps=varsout{9}  ;
        soc.fcm.info=varsout{10};
        soc.fcm.sols=varsout{11}  ;
        soc.fcm.weight=varsout{12} ;
        %NN
        soc.nn.check=varsout{13}  ;
        soc.nn.clust=varsout{14} ;
        soc.nn.learn=varsout{15} ;
        soc.nn.iters=varsout{16}  ;
        soc.nn.sols=varsout{17};
        soc.nn.weight=varsout{18};
        %QC
        soc.qc.check=varsout{19} ;
        soc.qc.sigma=varsout{20} ;
        soc.qc.iters=varsout{21} ;
        soc.qc.weight=varsout{22} ;
        handles.calcMapping=secondOrderClustering(soc,handles.data, 1);
        handles.note =  ['Second Order clustering '];
         case 6 %SVC
        [varsout{1:4}] = paramsForSVCDlg;
        mode = varsout{4};
        if mode ==0
            return
        end
        c = varsout{2};
        q = varsout{3};
        handles.calcMapping=SVClustering(handles.data', c,q);
        handles.note  = ['SVC (C = ', int2str(c), ' , q = ', num2str(q),')' ];
end
handles.stageSelected = 'next';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in backTag.
function backTag_Callback(hObject, eventdata, handles)
% hObject    handle to backTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.stageSelected = 'back';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);

function SaveASTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveAsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[varsout{1:4}] = fileBrowser;
dir  = varsout{2};
file = varsout{3};
format = varsout{4};
%realClassesTag
fullfile = [dir , '\',file];
saveas(handles.figure1,fullfile,format);


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function viewParallelCoordsTag_Callback(hObject, eventdata, handles)
% hObject    handle to viewParallelCoordsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function ViewMenu_Callback(hObject, eventdata, handles)
% hObject    handle to ViewMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function parallelCoordsBySamplesTag_Callback(hObject, eventdata, handles)
% hObject    handle to parallelCoordsBySamplesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


[varsout{1}]=parallelCoordsFig  ('mapping',handles.mapping,  'data',handles.data,'mode','samples');

% --------------------------------------------------------------------
function parallelCoordsByDimensionsTag_Callback(hObject, eventdata, handles)
% hObject    handle to parallelCoordsByDimensionsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[varsout{1}]=parallelCoordsFig ('mapping',handles.mapping,  'data',handles.data','mode','dims');


% --------------------------------------------------------------------
function plotOtherCoordinates_Callback(hObject, eventdata, handles)
% hObject    handle to plotOtherCoordinates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data =handles.data;
[x,y]= size (handles.mapping);
[x,yData] =size (data);
if y~=yData
    data = data';
end
[dims,length] = size(data);
[varsout{1:5}]=select3DimsFig('maxdims',dims);

if varsout{5} == 1 % apply
    dim1 = varsout{1};
    dim2 =varsout{2};
    dim3 = varsout{3};
    data = data([dim1 dim2 dim3],:);
    dimStr{1} = ['Dimension #' num2str(dim1)];
    dimStr{2} = ['Dimension #' num2str(dim2)];
    dimStr{3} = ['Dimension #' num2str(dim3)];
    hold off
    plotClassification(handles.mapping,  data',0,dimStr);
    if varsout{4}
        grid on
    else
         grid off
    end
end

