function varargout = clustersToolResults(varargin)
% CLUSTERSTOOLRESULTS M-file for clustersToolResults.fig
%      CLUSTERSTOOLRESULTS, by itself, creates a new CLUSTERSTOOLRESULTS or raises the existing
%      singleton*.
%
%      H = CLUSTERSTOOLRESULTS returns the handle to a new CLUSTERSTOOLRESULTS or the handle to
%      the existing singleton*.
%
%      CLUSTERSTOOLRESULTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLUSTERSTOOLRESULTS.M with the given input arguments.
%
%      CLUSTERSTOOLRESULTS('Property','Value',...) creates a new CLUSTERSTOOLRESULTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before clustersToolResults_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to clustersToolResults_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustersToolResults

% Last Modified by GUIDE v2.5 04-Jan-2012 23:45:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustersToolResults_OpeningFcn, ...
    'gui_OutputFcn',  @clustersToolResults_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before clustersToolResults is made visible.
function clustersToolResults_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to clustersToolResults (see VARARGIN)

% Choose default command line output for clustersToolResults
handles.output = hObject;
handles.stageSelected = 'end';
purity=0;
efficiency=0;
jaccard=0;
handles.data =[];
handles.realMapping =[];
handles.note=[];
handles.calcMapping=[];
handles.inputStr=[];
handles.dimsStr=[];
handles.QCFrames=0;
handles.movie=[];
handles.movieCreated = 0;
handles.SVCCores = -1;
handles.SVCCoresCreated = 0;
str =[];
str1=[];
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'jaccard'
                jaccard = varargin{index+1};
                %   set(handles.jaccardTextTag, 'String',dispStr );
            case 'purity'
                purity = varargin{index+1};
                %  set(handles.purityTextTag, 'String', ['Purity: ' ,num2str(purity)]);
            case 'efficiency'
                efficiency = varargin{index+1};
                % set(handles.efficiencyTextTag, 'String', ['Efficiency: ', num2str(efficiency)]);
            case 'realmapping'
                handles.realMapping=varargin{index+1};
            case 'data'
                handles.data =varargin{index+1};
            case 'calcmapping'
                handles.calcMapping=varargin{index+1};
            case 'note'
                handles.note = varargin{index+1};
            case 'inputstr'
                handles.inputStr= varargin{index+1};
            case 'dimsstr'
                handles.dimsStr = varargin{index+1};
            case 'qcframes'
                handles.QCFrames = varargin{index+1};
            case 'svccores'
                handles.SVCCores =  varargin{index+1};
        end
    end
end

%plot all the graphs
subplot(handles.peTag);
plotPEJ(handles.peTag,10,1,0);
hold on;
plot(efficiency,purity,'c*','LineWidth',8);
axis([0 1 0 1]);
grid on;
subplot(handles.realClassesTag);
plotClassification(handles.realMapping, handles.data,0);
subplot(handles.calcClassesTag);
markers = plotClassification(handles.calcMapping, handles.data,0);
set(handles.algorithmTextTag,'String',handles.note);
% Update handles structure
str= ['Results of ',handles.inputStr,': ',handles.note,char(10),num2str(max(handles.calcMapping)), ' clusters were detected. Jaccard score: ',num2str(jaccard),', Purity: ', num2str(purity),', Efficiency: '];
str1 = [num2str(efficiency),char(10), handles.dimsStr(1,:),char(10),handles.dimsStr(2,:)];
string=strcat (str,str1);
if max(handles.realMapping) >1% there are more than one cluster
    string=strcat (string, '. Elements are reordered for display purpose.');
end
set(handles.textTag,'String', string);
subplot(handles.plotClustTag);
%plotClustersInColors(realMapping,calcMapping,markers,handles.plotClustTag);
plotClusters(handles.calcMapping,handles.realMapping);
rotate3d on
if handles.QCFrames ~=0
    set(handles.RunMovieTag,'Enable','on');
    set(handles.originalTag,'Enable','on');
end
if handles.SVCCores ~= -1
    set(handles.originalTag,'Enable','on');
     set(handles.svcCoresTag,'Enable','on');
end
guidata(hObject, handles);
%
% UIWAIT makes clustersToolResults wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = clustersToolResults_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
varargout{2} = handles.stageSelected;
delete(handles.figure1);
% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --- Executes on button press in endTag.
function endTag_Callback(hObject, eventdata, handles)
% hObject    handle to endTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['End ' get(handles.figure1,'Name') '?'],...
    ['End ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

handles.stageSelected = 'end';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);


% --- Executes on button press in backTag.
function backTag_Callback(hObject, eventdata, handles)
% hObject    handle to backTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.stageSelected = 'back';
% Update handles structure
guidata(hObject, handles);
uiresume(handles.figure1);


% --------------------------------------------------------------------
function saveAsTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveAsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file, dir, filterindex] = uiputfile( ...
    {'*.fig', 'MATLAB figure Files (*.fig)';'*.bmp','Bitmap files (*.bmp)'; '*.eps','EPS Level 1 (*.eps)'; '*.*',  'All Files (*.*)'}, ...
    'Save as');
full_file = fullfile(dir,file);
if (filterindex~=0)
    saveas(handles.realClassesTag,full_file);
end

% --- Executes on button press in logTag.
function logTag_Callback(hObject, eventdata, handles)
% hObject    handle to logTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[varsout{1}]=clustersTextualResults('note',handles.note, 'dimsStr',handles.dimsStr,'inputStr',handles.inputStr,'real',handles.realMapping,'calc',handles.calcMapping);



% --------------------------------------------------------------------
function viewMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to viewMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function parallelCoordsTag_Callback(hObject, eventdata, handles)
% hObject    handle to parallelCoordsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function parallelCoordsBySamplesTag_Callback(hObject, eventdata, handles)
% hObject    handle to parallelCoordsBySamplesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[varsout{1}]=parallelCoordsFig                ('mapping',handles.calcMapping,  'data',handles.data,'mode','samples');
% --------------------------------------------------------------------
function parallelCoordsByDimensionsTag_Callback(hObject, eventdata, handles)
% hObject    handle to parallelCoordsByDimensionsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[varsout{1}]=parallelCoordsFig ('mapping',handles.calcMapping,  'data',handles.data,'mode','dims');




% --------------------------------------------------------------------
function plotOtherCoordinates_Callback(hObject, eventdata, handles)
% hObject    handle to plotOtherCoordinates (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data =handles.data;
[x,y]= size (handles.calcMapping);
[x,yData] =size (data);
if y~=yData
    data = data';
end
[dims,length] = size(data);
[varsout{1:5}]=select3DimsFig('maxdims',dims);

if varsout{5} == 1 % apply
    dim1 = varsout{1};
    dim2 =varsout{2};
    dim3 = varsout{3};
    data = data([dim1 dim2 dim3],:);
    dimStr{1} = ['Dimension #' num2str(dim1)];
    dimStr{2} = ['Dimension #' num2str(dim2)];
    dimStr{3} = ['Dimension #' num2str(dim3)];
    hold off
    subplot(handles.realClassesTag);
    plotClassification(handles.realMapping, data',0,dimStr);
    if varsout{4}
        grid on
    else
        grid off
    end
    subplot(handles.calcClassesTag);
    plotClassification(handles.calcMapping, data',0,dimStr);
    if varsout{4}
        grid on
    else
        grid off
    end
end


% --- Executes on button press in RunMovieTag.
function RunMovieTag_Callback(hObject, eventdata, handles)
% hObject    handle to RunMovieTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.calcClassesTag,'Visible','off');
child = get(handles.calcClassesTag,'children');
set(child,'Visible','off');
set(handles.simulationTag,'Visible','on');
if handles.movieCreated ~= 0
    movie(handles.simulationTag,handles.movie);
else
    subplot(handles.simulationTag);
     handles.movie = plotQCAnimation(handles.QCFrames,handles.calcMapping);
     handles.movieCreated = 1;
 end
guidata(hObject, handles);



% --- Executes on button press in originalTag.
function originalTag_Callback(hObject, eventdata, handles)
% hObject    handle to originalTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.simulationTag,'Visible','off');
child = get(handles.simulationTag,'children');
set(child,'Visible','off');
set(handles.calcClassesTag,'Visible','on');
child = get(handles.calcClassesTag,'children');
set(child,'Visible','on');





% --- Executes on button press in svcCoresTag.
function svcCoresTag_Callback(hObject, eventdata, handles)
% hObject    handle to svcCoresTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.calcClassesTag,'Visible','off');
set(handles.simulationTag,'Visible','on');
if handles.SVCCoresCreated == 0;
    handles.SVCCoresCreated = 1;
    subplot(handles.simulationTag);
    plotClassification(handles.SVCCores, handles.data,0,1);
else
    child = get(handles.simulationTag,'children');
    set(child,'Visible','on');
end
guidata(hObject, handles);
