% function compareMethodsTool main function
%
function [calcMapping2Plot]=compareMethodsTool
% initiate variables
state = 'start';
%dataInputStr = 'irisData';
%realOutputStr = 'irisRealMapping';
dataInputStr =[];
realOutputStr =[];
samplesAreRaws = 0.0;
dims = 0;
dataInput=[];
preprocessing=0;
dimsOption=0;
dimsStr=[];
dimsNote=[];
selectedDims=[];
useSVD=0;
toNormalize=1;
normVector = [];
realOutput=[];
calcMapping =[];
algorithm =1;
jm=0;
efficiency=0;
purity=0;
PE=0;
clusterColumns = 1;
vectorLength = 0;
originalOrder = [];
calcMapping2Plot=[];
bicIsOn =0; % calculate and display BIC
while 1%start the main loop
    if strcmp(state ,'start')==1
        varsout=selectData(dataInputStr,realOutputStr,samplesAreRaws);
        dataInputStr=varsout{2};
        realOutputStr=varsout{3};
        isCancel =varsout{5};
        if isCancel
            return
        else
            state = 'matrixShape';        
            dataInput =evalin('base',dataInputStr);
            [rows, cols] = size(dataInput);
            if rows > cols
                rank = cols;
            else
                rank = rows;
            end 
            dimsStr=num2str(rank);   
            dimsOption=0;
        end
    end
    if strcmp(state ,'matrixShape')==1 %next pressed 
        varsout1 = selectMatrixShape(rows,cols,clusterColumns);
        switch varsout1{4}%stage
            case 'cancel'  
                return
            case 'back'
                state = 'start';
                continue;
            case 'next'
                state = 'dims';
                if varsout1{2} == 1% to flip the matrix
                    dataInput =dataInput';% transpose
                    [rows, cols] = size(dataInput);
                end
                clusterColumns = varsout1{3} ;% rows (1) or columns (0)
                
                if clusterColumns==1
                    vectorLength = cols;
                else
                    vectorLength = rows;
                end
        end
    end
    if strcmp(state ,'dims')==1 %next pressed 
        matrixStr =[num2str(rows)  ' X ' num2str(cols)];
        varsout2=selectDims(rank ,dataInput,preprocessing,dimsOption,dimsStr,clusterColumns,matrixStr,bicIsOn);
        preprocessing=varsout2{3};
        if preprocessing >0
            useSVD=1;
            if preprocessing >1
                toNormalize =1;
            else
                toNormalize =0;
            end
        else
            useSVD =0;
            toNormalize=0;
        end
        selectedDims=varsout2{4};
        dimsOption=varsout2{5};
        dimsStr=varsout2{6};
        bicIsOn = varsout2{7};
        switch varsout2{2}
            case 'cancel'  
                return
            case 'back'
                state = 'matrixShape';
                continue;
            case 'next'   
                if isempty(realOutputStr)% if there is no output mapping --> we'll construct a dummy one
                    emptyRealMapping = 1;% a flag
                    realOutput = ones(vectorLength,1);
                    originalOrder=1:vectorLength;
                else
                    realOutput =evalin('base',realOutputStr);            
                    [dataInput,realOutput,originalOrder] =reorderData(dataInput,realOutput);
                    emptyRealMapping = 0;% a flag
                end  
                [normVector, numberOfGenes, numberOfSamples]= guiTruncateInputWithSelectedDims(dataInput, useSVD,selectedDims,0, clusterColumns,toNormalize);      
                state = 'method';
                continue;
        end% switch varsout{2}
    end %    if state =='dims' 
    if strcmp(state , 'method')==1
        varsout3 = selectMethod(realOutput,normVector,preprocessing,dimsStr,bicIsOn);       
        switch varsout3{2}
            case 'cancel'
                return
            case 'back'
                state = 'dims';
                calcMapping = [];
                dataInput =evalin('base',dataInputStr);
                if varsout1{2} == 1% to flip the matrix
                    dataInput =dataInput';% transpose
                    [rows, cols] = size(dataInput);
                end
                continue;
            case 'next'
                calcMapping =varsout3{3};
                algorithm = varsout3{4};
                note =varsout3{5};
                dimsNote = varsout3{6};
                QCFrames = varsout3{7};
                SVCCores = varsout3{8};
                state = 'results';
                nonemptyVector= find(calcMapping);%if I selected  'pure' QC I need to take only the non zero elements.
                calcToMeasure = calcMapping(nonemptyVector);
                realToMeasure = realOutput(nonemptyVector);
                [jm,efficiency, purity,PE] =myClustMeasure(calcToMeasure, realToMeasure,    emptyRealMapping);      
        end %switch varsout3{2}
    end%strcmp(state , 'method')==1
    if strcmp(state , 'results') ==1     
        %         [data2Plot,dummy1,dummy2] =reorderData(normVector,originalOrder);% need to reorder the vectors back to thier original order
        %         realMapping2Plot(originalOrder)=realOutput;
        calcMapping2Plot(originalOrder) = calcMapping;%reorder the calculation mapping tambien
        %calcMapping2Plot=calcMapping;
        realMapping2Plot=realOutput;
        data2Plot=normVector;
        varsout4 =  showResults(jm,purity,efficiency,realMapping2Plot,data2Plot,calcMapping,note,dataInputStr,dimsNote,QCFrames,SVCCores);%plot results
        switch varsout4{2}
            case 'end'
                return
            case 'back'
                state = 'method';
                continue;
        end
    end %if strcmp(state , 'results') ==1     
end%end while

%==============================================================================================================
%function varsout=selectData(dataInputStr,realOutputStr,samplesAreRaws);
function varsout=selectData(dataInputStr,realOutputStr,samplesAreRaws);
[varsout{1:5}] =clustersTool('dataInput',dataInputStr,'realOutput',realOutputStr,'samplesAreRaws',samplesAreRaws);
%==============================================================================================================
%function varsout=selectDims(dims,dataInput,preprocessing,dimsOption,dimsStr);
function varsout=selectDims(dims,dataInput,preprocessing,dimsOption,dimsStr,clusterColumns,matrixStr,bicIsOn);
[varsout{1:7}] =clustersTool2('maxdims',dims,'data',dataInput,'preprocessing' ,preprocessing,'dimsoption',dimsOption,'dimsstr',dimsStr,'clusterColumns',clusterColumns,'matrixstr',matrixStr,'bic',bicIsOn);
%==============================================================================================================
%function varsout=selectMethod(mapping,data,preprocessing,dims)
function varsout=selectMethod(mapping,data,preprocessing,dims,bicIsOn)
switch preprocessing
    case 0
        preprocessingStr =' using raw data';
    case 1
        preprocessingStr =' SVD was applied on data';
    case 2
        preprocessingStr =' SVD + normalization were applied on data';
end
if bicIsOn
    [varsout{1:8}] =clustersToolMethods('data',data,'mapping',mapping,'preprocessing',preprocessingStr,'dims',dims,'bic',bicIsOn);
else
    [varsout{1:8}] =clustersToolMethodsNoBIC('data',data,'mapping',mapping,'preprocessing',preprocessingStr,'dims',dims);
end

%==============================================================================================================
%function varsout =  showResults(jaccard,purity,efficiency,realmapping,data,calcMapping,note)
function varsout =  showResults(jaccard,purity,efficiency,realmapping,data,calcMapping,note,input,dimsStr,QCFrames,SVCCores)
if jaccard ==0
    jaccard = eps;
end
[varsout{1:2}]=clustersToolResults( 'jaccard',jaccard,'purity',purity,'efficiency',efficiency,...
    'realmapping',realmapping,'data',data,'calcMapping',calcMapping,...
    'note',note,'inputstr',input,'dimsStr',dimsStr,'qcframes',QCFrames,'svccores',SVCCores);

%==============================================================================================================
%   function vaesout = selectMatrixShape(rows,columns,toCluster)
%    decide whether to flip the matrix and what to cluster (rows or columns)
function varsout = selectMatrixShape(rows,columns,toCluster)
[varsout{1:4}] = matrixShapeDlg('rows',rows,'columns',columns,'toCluster',toCluster);
