function varargout = fileBrowser(varargin)
% FILEBROWSER Application M-file for fileBrowser.fig
%   FILEBROWSER, by itself, creates a new FILEBROWSER or raises the existing
%   singleton*.
%
%   H = FILEBROWSER returns the handle to a new FILEBROWSER or the handle to
%   the existing singleton*.
%
%   FILEBROWSER('CALLBACK',hObject,eventData,handles,...) calls the local
%   function named CALLBACK in FILEBROWSER.M with the given input arguments.
%
%   FILEBROWSER('Property','Value',...) creates a new FILEBROWSER or raises the
%   existing singleton*.  Starting from the left, property value pairs are
%   applied to the GUI before fileBrowser_OpeningFunction gets called.  An
%   unrecognized property name or invalid value makes property application
%   stop.  All inputs are passed to fileBrowser_OpeningFcn via varargin.
%
%   *See GUI Options - GUI allows only one instance to run (singleton).
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fileBrowser

% Last Modified by GUIDE v2.5 30-Nov-2003 14:46:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',          mfilename, ...
                   'gui_Singleton',     gui_Singleton, ...
                   'gui_OpeningFcn',    @fileBrowser_OpeningFcn, ...
                   'gui_OutputFcn',     @fileBrowser_OutputFcn, ...
                   'gui_LayoutFcn',     [], ...
                   'gui_Callback',      []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fileBrowser is made visible.
function fileBrowser_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fileBrowser (see VARARGIN)

% Choose default command line output for fileBrowser
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if nargin == 3,
    initial_dir = pwd;
elseif nargin > 4
    if strcmpi(varargin{1},'dir')
        if exist(varargin{2},'dir')
            initial_dir = varargin{2};
        else
             initial_dir = pwd;
%            errordlg('Input argument must be a valid directory','Input Argument Error!')
          %  return
        end
    else
        errordlg('Unrecognized input argument','Input Argument Error!');
        return;
    end
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'format'   
                a = varargin{index+1};
                set(handles.fileFormatTag,'String',a);
        end
    end
end
% Populate the listbox
load_listbox(initial_dir,handles)
% Return figure handle as first output argument
    
% UIWAIT makes fileBrowser wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = fileBrowser_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
if (~isempty(handles))
    varargout{1} = handles.output;
    varargout{2} = get(handles.dirTag,'String');%directory
    varargout{3} = get(handles.fileNameTag,'String');%file
    ind = get(handles.fileFormatTag,'Value');%file format
    formats = get(handles.fileFormatTag,'String');%file 
    if 1 ==iscell(formats)
        varargout{4} =  formats{ind};
    else
        varargout{4} =  formats;    
    end
    % The figure can be deleted now
    delete(handles.figure1);
end
% ------------------------------------------------------------
% Callback for list box - open .fig with guide, otherwise use open
% ------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

get(handles.figure1,'SelectionType');
if strcmp(get(handles.figure1,'SelectionType'),'open')
	index_selected = get(handles.listbox1,'Value');
	file_list = get(handles.listbox1,'String');	
	filename = file_list{index_selected};
	if  handles.is_dir(handles.sorted_index(index_selected))
		cd (filename)
		load_listbox(pwd,handles)
	else
	   [path,name,ext,ver] = fileparts(filename);
	   switch ext
	   case '.fig'
		   guide (filename)
	   otherwise 
		try
	    	open(filename)
		catch
			errordlg(lasterr,'File Type Error','modal')
		end
	   end	
   end
end
% ------------------------------------------------------------
% Read the current directory and sort the names
% ------------------------------------------------------------
function load_listbox(dir_path,handles)
cd (dir_path)
dir_struct = dir(dir_path);
[sorted_names,sorted_index] = sortrows({dir_struct.name}');
handles.file_names = sorted_names;
handles.is_dir = [dir_struct.isdir];
handles.sorted_index = [sorted_index];
guidata(handles.figure1,handles)
set(handles.listbox1,'String',handles.file_names,...
	'Value',1)
set(handles.dirTag,'String',pwd)


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




% --- Executes during object creation, after setting all properties.
function fileNameTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fileNameTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes during object creation, after setting all properties.
function fileFormatTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fileFormatTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in fileFormatTag.
function fileFormatTag_Callback(hObject, eventdata, handles)
% hObject    handle to fileFormatTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns fileFormatTag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from fileFormatTag

% --- Executes on button press in closeTag.
function closeTag_Callback(hObject, eventdata, handles)
% hObject    handle to closeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fileName = get(handles.fileNameTag,'String');
if isempty(fileName)
    errordlg('File name must be specified','Input Argument Error!');
    % elseif isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    %     % The GUI is still in UIWAIT, us UIRESUME
    %     uiresume(handles.figure1);
    % else    % The GUI is no longer waiting, just close it
    %     delete(handles.figure1);
    % end
    % Update handles structure
else
    guidata(hObject, handles);    
    % Use UIRESUME instead of delete because the OutputFcn needs
    % to get the updated handles structure.
    uiresume(handles.figure1);
end



function fileNameTag_Callback(hObject, eventdata, handles)
% hObject    handle to fileNameTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fileNameTag as text
%        str2double(get(hObject,'String')) returns contents of fileNameTag as a double


