function [mapping]=findMinima(indices,potential)
% 1: check if the data is 2 dimensional:
[x,y] = size (indices);
if x ==2
    indices = indices';% easier to work like this
elseif y == 2
    ;% do nothing it is ok
else
    error('findMinima: Bad input: data is must be 2 dimensional'); 
end
    
%2 check the second input
if length(potential)~=x
     error('findMinima: Bad input: potentials must be and data must be identical'); 
 end

 [x1,y1] = size(potential);
if x1~=x
    potential = potential';
end
[x1,y1] = size(potential);

if x1~=x
     error('findMinima: Bad input: potentials and data length must be identical'); 
 end
 if y1~=1
       error('findMinima: Bad input: potentials must be a vector'); 
 end 
 [theta,RHO] = cart2pol(indices(:,1),indices(:,2)); %RHO is all '1'...
 % now we sort the angels 
  [s,inds]=sort(theta);
 sortedPotentials = potential(inds);
[MinVals MinInds]=lmin(sortedPotentials,2);% find the local minima
[MaxVals MaxInds]=lmax(sortedPotentials,2);% find the local maxima
figure;hold on;
plot(theta,potential,'r*');
plot(s(MinInds),sortedPotentials(MinInds),'b+');
plot(s(MaxInds),sortedPotentials(MaxInds),'y+');
mapping= ones(x,1);
for ind=2:length(MaxInds)%number of basins
    startGroup =MaxInds(ind-1);
    endGroup=MaxInds(ind);
    group=inds(startGroup:endGroup);
    mapping(group)=ind;
end