%   function [normVector]=  guiTruncateInput: data and whether to use SVD is
%   known
%   initial steps: read input, run svd, truncate dimentions
%   Input:
%   data              samples*genes matrix
%   withSVD     boolean flag
%   numOfDims number of dimention
%   toPlot - boolean to plot or not the S values (default ==true)
%   toNormalize - boolean: to normalize the result of SVD (default == true)
%   Output:
%   normVector - 
%   numberOfSamples 
%   numberOfGenes
%   replicationsArray - an array that maps between a sample and it replications (participant) 
function [normVector, numberOfGenes, numberOfSamples]= guiTruncateInput(data, withSVD,numOfDims,toPlot, toNormalize)
[numberOfGenes,numberOfSamples] = size(data);
[eigenSamples,S,eigenGenes] = svd(data,0);%   svd the input    X = USVt because genes information is displaeyd in eigensamples base and vice versa
eigenGenes=eigenGenes'; % because the SVD returns the  transpose
[x,y] =size(S);% it isn't always equal
if x~=y
    minDim = min(x,y);
    S = S(1:minDim,1:minDim);% make it square
end
if nargin ~= 4 || toPlot ~=0    
    [dims] = estimateNumberOfSignificantDims(S,1);  % number of significant dimension to process
end
if withSVD==0
    eigenGenes = data;
end
significantVector = eigenGenes(1:numOfDims,:); %  get only numOfDims significant samples X = USVt because samples information is displaeyd in eigengenes base    

if nargin ~=5 || toNormalize ~=0
    normVector = normc(significantVector)';% normalize the matrix
else
    normVector =normVector';
end