%   function [normVector]=  guiTruncateInput: data and whether to use SVD is
%   known
%   initial steps: read input, run svd, truncate dimentions
%   Input:
%   data              samples*genes matrix
%   withSVD     boolean flag
%   numOfDims number of dimention
%   toPlot - boolean to plot or not the S values (default ==true)
%   toNormalize - boolean: to normalize the result of SVD (default == true)
%   clusterRows - whether to cluster rows or samples
%   Output:
%   normVector - 
%   numberOfSamples 
%   numberOfGenes
%   replicationsArray - an array that maps between a sample and it replications (participant) 
function [normVector, numberOfGenes, numberOfSamples]= guiTruncateInputWithSelectedDims(data, withSVD,setectedDims,toPlot, clusterColumns,toNormalize)
needToTranspose=0;
numOfDims = length(setectedDims);
[numberOfGenes,numberOfSamples] = size(data);
if numberOfGenes<numberOfSamples
    data=data';% transpose only because it is easy for the svd
    needToTranspose = 1; % flag
end
[eigenSamples,S,eigenGenes] = svd(data,0);%   svd the input    X = USVt because genes information is displaeyd in eigensamples base and vice versa
if needToTranspose ==1%swap the matrices
    temp = eigenGenes;
    eigenGenes = eigenSamples';
    eigenSamples = temp';
end
eigenGenes=eigenGenes'; % because the SVD returns the  transpose
[x,y] =size(S);% it isn't always equal
if x~=y
    minDim = min(x,y);
    S = S(1:minDim,1:minDim);% make it square
end
%if nargin ~= 4 || toPlot ~=0    Roy 5/11: the condition isn't good for
%compareMethodTool...
if toPlot ~=0   
    [dims] = estimateNumberOfSignificantDims(S,1);  % number of significant dimension to process
end

if clusterColumns==1% ~cluster samples
    vector = eigenGenes;
else % ~cluster genes
    vector = eigenSamples';
    
end

if withSVD==0% parameter flag ==> use the original data
    if clusterColumns==0 % cluster rows
        data = data';
    end
    vector = data;
end

if needToTranspose==1
    vector = vector';% re-transpose the matrix
end
if withSVD
    significantVector = vector(setectedDims,:); %  get only numOfDims significant samples X = USVt because samples information is displaeyd in eigengenes base    
else
    significantVector = vector;
end
if nargin ~=6 || toNormalize ~=0
    normVector = normc(significantVector)';% normalize the matrix
else
    normVector =significantVector';
end
 
% add NaN validation
normVector(find(isnan(normVector))) = eps;