%   function [] = plotClassification(mapping,  data)
% plot the classification of the input data
%   input=
%   mapping - classification of points
%   data - data points
%   w - centers of the clusters
% dimStr - [optional] - labels display
function [markers] = plotClassification(mapping,  data,w,corePlot,dimStr)
[x,y]= size (mapping);
[x,yData] =size (data);
if y~=yData
    data = data';
end
if nargin == 2 % w is not known
    w = 0;
end
if nargin < 4
    corePlot = 0;
end
classes = max(mapping);
[dims,length] = size(data);% first dimension of the data matrix
markers =['k';'r';'b';'g';'c';'y'];
for ind = 1:classes% for each class: display the points
    clust = find(mapping == ind);
    clustPoints=data(:,clust);
    % dotsFormat = ['*',markers(ind)];
    %plotTruncateData(clustPoints,w,dims,dotsFormat);%  plot points of the ind cluster
    if ind > size(markers)
        color =[( (ind-1)/classes) (1-ind/classes) ((ind-mod(ind,2))/classes)];
    else
        color = markers(ind);
    end
    if nargin > 4
        plotTruncateData(clustPoints,w,dims, color,dimStr);%  plot points of the ind cluster%   different color for each class
    else
        plotTruncateData(clustPoints,w,dims, color);%  plot points of the ind cluster%   different color for each class
    end
end
if corePlot == 1
    lightGrey = 211/255;
    color = [lightGrey,lightGrey,lightGrey];
     clust = find(mapping == 0);
    clustPoints=data(:,clust);
    if nargin > 4
        plotTruncateData(clustPoints,w,dims, color,dimStr);%  plot points of the ind cluster%   different color for each class
    else
        plotTruncateData(clustPoints,w,dims, color);%  plot points of the ind cluster%   different color for each class
    end
end
%grid off
if dims > 2
    view(-100,10);
    rotate3d on
end
