% mode 1 - by samples
% mode 2 - by dimensions
function[]=plotClassificationInParallelCoordinates(data,mapping,mode)
%h = gca;
classes = max(mapping);
%if classes >1
   % newplot(h);
%end
[x,y]= size (mapping);
[x,yData] =size (data);
if y~=yData
    data = data';
end
switch classes
    case 1 %no real classification
        plot(data);
    case 2
        drawSubPlot(data,mapping,2, 1,[1 2],mode);
    case 3
        drawSubPlot(data,mapping,3, 1,[1 2 3],mode);
    case 4
        drawSubPlot(data,mapping,2, 2,1:4,mode);
    case 5
        drawSubPlot(data,mapping,3, 2,1:5,mode);
    case 6
         drawSubPlot(data,mapping,3, 2,1:6,mode);
    case 7
        drawSubPlot(data,mapping,3, 3,1:7 ,mode);
    case 8      
     drawSubPlot(data,mapping,3, 3,1:8,mode);
    otherwise %>=9
        drawSubPlot(data,mapping,3, 3,1:9,mode);          
end

function [] =drawSubPlot(data,mapping,rows, cols,indices,mode)
markers =['k';'r';'b';'g';'c';'y';'k';'r';'b';'g'];
for ind =1 :length(indices)
    subplot(rows,cols,indices(ind));
    clust = find(mapping == ind);
    clustPoints=data(:,clust);
    if mode ==1% mode 1 - by samples
        plot (clustPoints');
        xlabel('Sample');
    else % % mode 2 - by dimensions
        plot (clustPoints,'Color',markers(ind));
        xlabel('Dimension');
    end
    title(['Cluster # ' num2str(ind)]);
end

