%function [ ]= plotClustersInColors(realClass,calcClass,colorVec, h)
% assumption : real classes are sorted: [ 1 1 1 2 2 2 2 3 3....numOfRealClasses numOfRealClasses]
function [ ]= plotClustersInColors(realClass,calcClass,colorVec, h)
if nargin < 4% no input figure;
    figure;
end
hold on;
if length(realClass) ~=length(calcClass)
    errordlg('Number of elements in real classification and in calculated classification must be equal','Incorrect value','modal');   
    return;
end
     
len = length(calcClass);
stemVector= zeros(1,len);
numOfRealClasses = max(realClass);
for ind = 2: numOfRealClasses %first starts in one
    stemVector(min(find(realClass == ind))) = 2;% constructing [ 0 0 0 0 3 0 0 0...] vector, when the '2' are places where new cluster starts
end
hs =stem(stemVector);
set(hs(2),'Color','k','LineWidth',2); % Set stem line properties
set(hs(1),'Color','k','MarkerSize',0.1) ;% Set points 'invisible'
y = [1 0 0 1];% y values of the square
for ind = 1: len
    x = [ind ind ind+1 ind+1];% y values of the square
    class = calcClass(ind);
    colInd = mod (class,length(colorVec));
    if colInd == 0
        colInd = length(colorVec);
    end
    color = colorVec(colInd);
    fill (x,y,color);
end
axis ([ 1  len+1 0 2]);