%   function [] = plotPEJ(h,numOfCurves,isPlot)
%     plot the purity as function of the efficiency when the jaccard is known,
%     Input:
%     h - handler to the figure object;
%     numOfCurves - number of fixed jaccard values
%     isPlot - true - plot, fals - area
    
function [] = plotPEJ(h,numOfCurves,isPlot,showLegend)
e = [0:.02:1];
j = 0;%jaccard
j = j +1/numOfCurves;
for ind = 1:numOfCurves
    eStart = (j/(j+1));
    el = zeros(size(e));
    el(find(e>eStart)) = e(find(e>eStart));
    pTemp = (j*el)./(el+j*el-j);
    pTemp(find(pTemp==0)) = 1;
    p(ind,:) = pTemp;
    legendStrings(ind) = {['Jaccard = ' ,num2str(j)]};
    j = j +1/numOfCurves;    
end
p(find(isnan(p))) = 0; % make the NaN == 0

if nargin < 3 || isPlot ~= 0
    plot(e,p');
else
    [x,y] = size(p);
    shiftP(2:x+1,:) = p;
    p(x+1,:) = 0;
    diffsP = p-shiftP;
    diffsP = diffsP(1:x,:);
    area(e,diffsP');
end
axis([0 1 0 1]);
grid
% xlabel('Efficiency');
% ylabel('Purity');
if showLegend
    legend(legendStrings);
end
