function [mat]=plotRecTree(tree,inputStruct,partitionMatrix)
for ind = 1:length(tree)-1
    leftInd =findElementIndex(ind, 2,tree);
    mat(ind,1) = leftInd;
    rightInd =findElementIndex(ind, 3,tree);
    mat(ind,2) = rightInd;
end
% fix all the leaves
ind =ind+1;
mat(ind,1) = -1;
mat(ind,2) = -1;

numOfClusters =max(max(mat));
[x,y] = find(mat <0);
for ind = 1:length(x)
    mat(x(ind),y(ind)) = numOfClusters+ind;
end
p(1) =0;
for ind =2: max(max(mat));
    [ x,y] = find (mat ==ind);
    p(ind) =x;
end
figure;
treeplot(p,'.k','-k');
if ~isempty(inputStruct.realMappingStr)
    hold on
    realMapping=paintLeavesFromReal (tree,p,inputStruct);%assign the true colors to the edges
    [enrichmentMatrix] = calculateEnrichment(partitionMatrix, realMapping);% find 'good' partitions
    paintEnrichedVertices(p,enrichmentMatrix); % point the 'good' partitions
end
axis off

function [retInd] =findElementIndex(currInd, column,tree)
str = tree{currInd,column};
retInd=-1;
if  currInd< length(tree)
    for ind =currInd+1:length(tree)
        if isequal (tree{ind,1},str)
            retInd = ind;
            break;
        end
    end
end

function [realMapping]  = paintLeavesFromReal (tree,p,inputStruct)
realMapping =evalin('base',inputStruct.realMappingStr);
numElems = inputStruct.numelems;
paintLeaves(tree,p,realMapping,numElems);

function []= paintLeaves(tree,p,realMapping,numElems)
markers =['k';'r';'b';'g';'c';'y'];
[x1,y1,h]=treelayout(p);
for ind = 1:length(tree)
    x= find(p == ind);
    y = find(x>= numElems);
    for jnd = 1:length(y)
        num = str2num(tree{ind,y(jnd)+1});
        if length(num) ~=1
            num = str2num(tree{ind,3});
        end
        if length(num)~=1
            num = str2num(tree{ind,2});
        end
        if length(num)==1
            clust =realMapping(num);
            plot(x1(x(y(jnd))), y1(x(y(jnd))), 'o','Color',markers(clust));
        end
    end
end
% %find the significant vertices + normalize them
% function [vals,inds] = findSignificantVertices(enrichmentMatrix)
% y=enrichmentMatrix;
% y(find(enrichmentMatrix <eps)) =1e-14;
% y(find(enrichmentMatrix > 0.05)) =1;
% y=log(y);
% y=-y;
% y(find(enrichmentMatrix > 0.05)) =1;
% y=log(y);
% [vals,inds]=max(y');
% maxVal = max(vals);
% minVal = min(vals(find(vals)));
% vals = 1+10*(vals-minVal);% 3 is the best (?) max -min
% point the 'good' partitions
function []=paintEnrichedVertices(p,enrichmentMatrix); 
[vals,inds] = findSignificantVertices(enrichmentMatrix);
markers =['k';'r';'b';'g';'c';'y'];
[x1,y1,h]=treelayout(p);
for ind = 1:length(inds)
    if vals(ind)> 0
        plot(x1(ind+1), y1(ind+1), '.','Color',markers(inds(ind)),'MarkerSize',vals(ind));
    end
end
