%   function = plotTruncateData(normVector,w,dims,dotsFormat)
%   Input:
%   normVector - input data
%   w - centers (weights)
%   dims - number of dimensions
%   dotsFormat - e.g. '+'r'
% dimStr - x, y and (z) lables display 
function []= plotTruncateData(normVector,w,dims,color,dimsStr)

if dims == 2   
    plot(normVector(1,:),normVector(2,:),'*','Color',color);
    hold on;
    if length(w)>1
        circles = plot(w(:,1),w(:,2),'ob');
    end
elseif dims >= 3
    plot3(normVector(1,:),normVector(2,:),normVector(3,:),'*','Color',color);
    hold on;
    if length(w) >1
        circles = plot3(w(:,1),w(:,2),w(:,3),'ob');
    end
else
        ;
end
title('Input Vectors');
if nargin < 5 % no dim Str given
    xlabel('dimension 1');
    ylabel('dimension 2');   
else
    xlabel(dimsStr{1});
    ylabel(dimsStr{2});   
end
    if dims >=3
        if nargin < 5 % no dim Str given
            zlabel('dimension 3');
        else
            zlabel(dimsStr{3});
        end
end
