%QCCLUSTERINGANIMATION Summary of this function goes here
%   Detailed explanation goes here
function [mapping,DFrames] = qcClusteringAnimation(sigma,steps,data,eta,rescale,doRecurse,show,numOfClusters)
[dims,samples] = size(data);
if nargin < 4
    eta = 0.1;
end
if nargin < 5
    rescale = 0;
end
if nargin<6 || doRecurse ==1
    doRecurse=1;
end
if nargin < 7
    show = doRecurse;
end
if nargin <8 ||   numOfClusters<2
    numOfClusters = dims;
end
q=1/(2*sigma^2);
[D,DFrames]=graddescAnimation(data,q,steps,eta,rescale,show);   % performs gradient descent on xyData with steps + show progress bar (only in a recurse mode
D(find(isnan(D))) = 0;
dMax = sum((max(D) - min(D)).^2);
if dMax ==0
    errordlg('Points could not converge','Bad Input','modal');  
    D = data;
    dMax= sum((max(D) - min(D)).^2);
end
if doRecurse ==1
     [V,P,E,dV] = qc (data,q,D);% calculate the potential of the new points
     newData = [D,V] ;% the new data is the converged points + the potential
    mapping = qcClustering(sigma,3,newData,eta,0,0);% call again -- the recursion (only 3 times more)
else
    dist=sigma/2;
    mapping =fineCluster(D,dist)';
end

end

