function [inputStruct] = readInputFile(filename)
fid = fopen(filename, 'rt');
if fid < 0
    error( ['File ' ,filename ,' was not found. Please try again']);
end
line = 1;
inputStruct= initStruct;
while feof(fid) == 0
    tline = fgetl(fid);
    if tline(1) == '%'
        continue;% comment
    end
    pos =strfind(tline,'=');
    if length(pos)~=1 | pos < 1 | pos == length(tline)%only one '=' is allowed , musn't be the first not the last
        error(['Error: line ', num2str(line) ,'. The format of each line should be: "field = value"']);
    end
    field= tline(1:pos-1);
    value = tline(pos+1:length(tline));
    inputStruct = fillStruct(inputStruct,field,value);
    line = line +1;
end
fclose(fid);
% internal functions

function [inputStruct]= initStruct();
inputStruct.dataInputStr =[];
inputStruct.realMappingStr =[];
inputStruct.preprocessing=0;
inputStruct.dims = [];
inputStruct.clustercolumns =1;
inputStruct.algorithm =0;
inputStruct.numclust =0;
%inputStruct.setelements=[];
inputStruct.numelems=0;
inputStruct.iscorr=0;
%QC specific
inputStruct.sigma = 0;
inputStruct.steps =0;
inputStruct.ratio =0;

function [inputStruct] = fillStruct(inputStruct,field,value)

% 
% samplesAreRaws = 0.0;
% 
% dataInput=[];
% 
% dimsOption=0;
% dimsStr=[];
% dimsNote=[];
% selectedDims=[];
% useSVD=0;
% toNormalize=1;
% normVector = [];
% realOutput=[];
% calcMapping =[];
% 
% jm=0;
% efficiency=0;
% purity=0;
% PE=0;
% clusterColumns = 1;
% vectorLength = 0;
% originalOrder = [];
% calcMapping2Plot=[];

%field =  strtrim(field);
%value =  strtrim(value);
    switch lower(field)
        case 'data'
            if ischar(value)
                inputStruct.dataInputStr     = value;
            else
                error('Error: data must be a name of and existing matlab variable');
            end
        case 'realmapping'
            if ischar(value)
                inputStruct.realMappingStr     = value;
            else
                error('Error: realmapping must be a name of and existing matlab variable');
            end
        case 'preprocessing'
            num = str2num(value);
            if ( length(num) < 1 ) | (0 == isnumeric(num))  |  (num ~=0 &num ~=1 & num ~=2)
                error('Error: preprocessing must be an integer number with values: 0 (no preprocessing), 1 (only SVD) and 2 (SVD + normalization)');
            else
                inputStruct.preprocessing = num;
            end
        case 'dims'
            num = str2num(value);%[1:3], '[1,3:4], [1,3,5]
            if length(num)<1 | 0 == isnumeric(num)
                error('Error: dims must be an integer array with numbers greater than 0');
            else
                inputStruct.dims =num;
            end
        case 'clustercolumns'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | (num~=0&num~=1)
                error('Error: clustercolumns must be an integer with values 0 (cluster rows) or 1 (cluster columns)');
            else
                inputStruct.clustercolumns = num;
            end
        case  'algorithm'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | num<1 | num > 4
                error('Error: algorithm must be an integer with values greater than  1');
            else
                inputStruct.algorithm = num;
            end
        case 'sigma'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | num<0
                error('Error: sigma must be a number greater than  0');
            else
                inputStruct.sigma = num;
            end
        case 'numclust'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | num<1
                error('Error: numclust must be a number greater than  1');
            else
                inputStruct.numclust = num;
            end
        case 'steps'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | num<0
                error('Error: steps must be an integer greater than  0');
            else
                inputStruct.steps = num;
            end
         
        case 'ratio'
            num =str2num(value);
            if length(num)~=1 | 0==isnumeric(num) | num<0| num >100
                error('Error: ratio must be a number greater than  0 and not greater than 100');
            else
                inputStruct.ratio = num;
            end
        case 'numelems'
            num=str2num(value);
            inputStruct.numelems=num;
        case 'iscorr'
            num=str2num(value);
            inputStruct.iscorr=num;
    end


