%   function [refClust] = referenceClustering(dataPoints,numOfClusters)
%   uses the 'fcm' library funnction for comparison
%   input -
%   dataPoints: matrix each row is a point (in a | column | space dimension
%   numOfClusters: number of clusters
%   exp - exponent for the partition matrix U (default: 2.0) 
%   iter    - smaximum number of iterations (default: 100)
%   eps - minimum amount of improvement (default: 1e-5)
%   info    - info display during iteration (default: 1)
%   output -
%   refClust:   an array: each cell represents the classificationof the point

function [refClust] = referenceClustering(dataPoints,numOfClusters,exp,iters,eps,info)
if numOfClusters < 1
    error('Bad input: number of clusters (second argument) must be greater than 0!');
end
options = [exp ,iters, eps,info];
[center,U,obj_fcn] = fcm(dataPoints, numOfClusters,options);
maxU = max(U);
for ind =1: numOfClusters
    index = find(U(ind, :) == maxU);
    refClust(index)=ind;
end