% function [newDataMatrix,newRealMapping,originalOrder] =reorderData(data,realMapping)
% function oreder it's columns so all clusters will be groupd (cluster 1: [1  x], cluster 2: [x+1 y]... cluster 3: [z+1 numOfSamples]
%     Input: 
% data - raw data before reordering
% realMapping - samples tagging before reorderring
% Output:
% newDataMatrix - data after reordering
% newRealMapping - samples tagging after reorderring ([1111... 2222.... xxxx])
% originalOrder - the original indices (1 4 2 5 3 ...) this variable is
% important in order to return plot the results (user should see the
% elements in thier original orders)
function [newDataMatrix,newRealMapping,originalOrder] =reorderData(data,realMapping)
% initialization
needToTransposeAgain=0;
[x,y] =size (realMapping);
if y == 1% adjust the realMapping vector
    realMapping=realMapping';
    [x,y] =size (realMapping);% and again...
end
newRealMapping =zeros(x,y);
originalOrder = zeros(x,y);%initiate this vector also
[x,yData] =size (data);
if (yData~=y)% adjust the input
    data =data';
    needToTransposeAgain = 1;%we fliped the data matrix: need to flip it again when returning
    [x,yData] =size (data);% and again...
end
newDataMatrix =zeros(x,y);

numOfClusters = max(realMapping);
count =0;
for ind =1: numOfClusters
    indices = find (realMapping==ind);
    vectors = data(:,indices);
    len =length(indices);
    newDataMatrix(:,count+1:count+len)=vectors;
    newRealMapping(count+1:count+len) = ind;
    originalOrder(count+1:count+len) = indices;
    count =count +len;
end

if needToTransposeAgain==1%we fliped the data matrix: need to flip it again when returning
    newDataMatrix=newDataMatrix';
end
if 1 == max(realMapping)
    originalOrder = [1:1:length(originalOrder)];
end