% function compareMethodsTool main function
%
function [calcMapingFull,jm,efficiency, purity,globalMin]=silentCompareMethodsTool(filename,show,inputStruct,elemAsStr)
% initiate variables
jm =0;
efficiency=0;
purity=0;
globalMin=0;

if nargin <3    
     inputStruct = readInputFile(filename);      
end
 if nargin <3   |  isempty(inputStruct)
     dataInput =evalin('base',inputStruct.dataInputStr);
     elemAsStr = num2str(1:inputStruct.numelems);
 end
[dataInput,emptyRealMapping,realOutput ]= fillDataInput(inputStruct,elemAsStr);
relevantElements =str2num(elemAsStr);
[rows, cols] = size(dataInput);
if rows > cols
    rank = cols;
else
    rank = rows;
end
dimsStr=num2str(rank);
dimsOption=0;


clusterColumns = inputStruct.clustercolumns ;% rows (1) or columns (0)

if clusterColumns==1
    vectorLength = cols;
 %   nElems=rows;
else
    vectorLength = rows;
%     nElems=cols;
end

matrixStr =[num2str(rows)  ' X ' num2str(cols)];
preprocessing=inputStruct.preprocessing;
if preprocessing >0
    useSVD=1;
    if preprocessing >1
        toNormalize =1;
    else
        toNormalize =0;
    end
else
    useSVD =0;
    toNormalize=0;
end
selectedDims=inputStruct.dims;;

if length(selectedDims)> (vectorLength/6) % small group : less dims
    nDims = round(vectorLength/6);
    if nDims<2| vectorLength<=2
        nDims = 2;
    end
    selectedDims =selectedDims(1:nDims);
end

dimsStr=num2str(selectedDims);

if emptyRealMapping==0
    [dataInput,partialRealOutput,partialOriginalOrder] =reorderData(dataInput,realOutput(relevantElements));;
else
    partialRealOutput=realOutput(relevantElements);
    partialOriginalOrder = 1:length(relevantElements);
end
[normVector, numberOfGenes, numberOfSamples]= guiTruncateInputWithSelectedDims(dataInput, useSVD,selectedDims,0, clusterColumns,toNormalize);

switch inputStruct.algorithm
    case 1% kmeans (from the statistical toolbox
        numOfClusters =inputStruct.numclust; 
        calcMapping = kmeans(normVector,numOfClusters);
        note =['Kmeans Classification' ];
    case 2%fuzzy kmeans  
        numOfClusters =inputStruct.numclust; 
        exp=2;%meanwhile
        iters=inputStruct.steps; 
        eps=.2;%varsout{4};
        info=0;% 
        calcMapping = referenceClustering(normVector,numOfClusters,exp,iters,eps,info);
        note =['Fuzzy c means Classification' ];
    case 3%NN
        learningRate = inputStruct.sigma;
        steps = inputStruct.steps;
        nClust = inputStruct.numclust; 
        calcMapping = cnnClustering(steps,learningRate, normVector,1,nClust);
        note =  ['Competitive NN Classification (', int2str(steps), ' iterations)' ];
    case 4%QC
        sigma = inputStruct.sigma;
        steps = inputStruct.steps;
        usePureQc=1;
        percent = inputStruct.ratio;
        [calcMapping,globalMin]= pureQC(normVector, sigma,steps,percent,show,1);
        note  = ['Pure QC Classification (', int2str(steps), ' iterations, sigma = ', num2str(sigma),', percent of pure elements: ', num2str(percent),')' ];             
end
calcMapingFull = zeros(inputStruct.numelems,1);
calcMapingFull(relevantElements)=calcMapping;
nonemptyVector= find(calcMapingFull);%if I selected  'pure' QC I need to take only the non zero elements.
calcToMeasure = calcMapingFull(nonemptyVector);

realToMeasure = realOutput(nonemptyVector);
[jm,efficiency, purity,PE] =myClustMeasure(calcToMeasure, realToMeasure,    emptyRealMapping);      
calcMapping2Plot=zeros(inputStruct.numelems,1);
realMapping2Plot=zeros(inputStruct.numelems,1);
calcMapping2Plot(partialOriginalOrder) = calcToMeasure;%reorder the calculation mapping tambien
%calcMapping2Plot=calcMapping;
realMapping2Plot(partialOriginalOrder)=realToMeasure;
data2Plot=normVector;
b(1,:) =note;
b(2,:)=note;
if show
    varsout4 =  showResults(jm,purity,efficiency,realMapping2Plot,data2Plot,calcMapping,note,inputStruct.dataInputStr,b);%plot results
end










%==============================================================================================================
%function varsout =  showResults(jaccard,purity,efficiency,realmapping,data,calcMapping,note)
function varsout =  showResults(jaccard,purity,efficiency,realmapping,data,calcMapping,note,input,dimsStr)
if jaccard ==0
    jaccard = eps;
end
[varsout{1:2}]=clustersToolResults( 'jaccard',jaccard,'purity',purity,'efficiency',efficiency,...
    'realmapping',realmapping,'data',data,'calcMapping',calcMapping,...
    'note',note,'inputstr',input,'dimsStr',dimsStr);

