%   function [normVector]=  truncateInput: data and whether to use SVD is
%   known
%   initial steps: read input, run svd, truncate dimentions
%   Input:
%   data              samples*genes matrix
%   withSVD     boolean flag
%   numOfDims number of dimention
%   Output:
%   normVector - 
%   numberOfSamples 
%   numberOfGenes
%   replicationsArray - an array that maps between a sample and it replications (participant) 
function [normVector, numberOfGenes, numberOfSamples]= truncateInput(data, withSVD,numOfDims)
[numberOfGenes,numberOfSamples] = size(data);
[eigenSamples,S,eigenGenes] = svd(data,0);%   svd the input    X = USVt because genes information is displaeyd in eigensamples base and vice versa
[x,y] =size(S);% it isn't always equal
if x~=y
    minDim = min(x,y);
    S = S(1:minDim,1:minDim);% make it square
end
 [dims] = estimateNumberOfSignificantDims(S,1);  % number of significant dimension to process
if withSVD==0
    eigenGenes = data;
end
significantVector = eigenGenes(1:numOfDims,:); %  get only numOfDims significant samples X = USVt because samples information is displaeyd in eigengenes base    
normVector = normc(significantVector)';% normalize the matrix